
function dictionary ( strName, strUrlBase, strLanguages, strUrlSearch, strCssUrl )
{
	this.m_strName = strName;
	this.m_strUrlBase = strUrlBase;
	this.m_strLanguages = strLanguages;
	this.m_strUrlSearch = strUrlSearch;
	this.m_cssStyleUrls = new Array;
	
	for ( var i = 4; i < arguments.length; i++ )
		this.m_cssStyleUrls.push ( arguments [ i ] );
}


var dictGoogle = new dictionary ( 
					"google", 
					"www.translate.google.com/translate_t",
					new Array (
						"ENDE", "en|de", "DEEN", "en|de",
						"FRDE", "fr|de", "DEFR", "fr|de",
						"ESDE", "es|de", "DEES", "es|de",
						"ITDE", "it|de", "DEIT", "it|de"
					),
					
					"http://translate.google.com/translate_t?hl=&ie=UTF8&text={search}&langpair={urlLanguagePart}#" );
					
					
var dictLangenscheidt = new dictionary ( 
					"langenscheidt", 
					"www.wissen.de/wde/generator/wissen/ressorts/bildung/woerterbuecher/index.html",
					new Array (
						"ENDE", "en", "DEEN", "en",
						"FRDE", "fr", "DEFR", "fr",
						"ESDE", "es", "DEES", "es",
						"TRDE", "tr", "DETR", "tr"
					),
					"http://www.wissen.de/wde/generator/wissen/services/suche/wb/index.html?dictqry={searchEncoded}&dictqry2={search}&Start=%A0%A0Suchen%A0%A0&dictlang={urlLanguagePart}" );
					
					
var dictLeo = new dictionary ( 
					"leo", 
					"www.leo.org",
					new Array (
						"FRDE", "frde", "DEFR", "defr",
						"ITDE", "itde", "DEIT", "itde", 
						"ESDE", "esde", "DEES", "esde", 
						"ENDE", "ende", "DEEN", "ende", 
						"CNDE", "chde", "DECN", "chde"
					),
					"http://dict.leo.org/{urlLanguagePart}?lp={urlLanguagePart}&search={search}" );
					
					
var dictReverso = new dictionary (
					"reverso", 
					"www.reverso.net",
					new Array (
						"ESDE", "spanisch-deutsch", 		"DEES", "deutsch-spanisch", 
						"FRDE", "franzosisch-deutsch", 		"DEFR", "deutsch-franzosisch", 
						"ITEN", "italienisch-englisch",		"ENIT", "englisch-italienisch",
						"PREN", "portugiesisch-englisch",	"ENPR", "englisch-portugiesisch",
						"ENCN", "englisch-chinesisch",		"CNEN", "chinesisch-englisch",
						"ENDE", "englisch-deutsch",			"DEEN", "deutsch-englisch",
						"ENRU", "englisch-russisch",		"RUEN", "russisch-englisch"
					),
					"http://woerterbuch.reverso.net/{urlLanguagePart}/{search}" );
					

var dictPons = new dictionary (
					"pons", 
					"pons.eu",
					new Array (
						"FRDE", "defr",	"DEFR", "defr", 
						"ITDE", "deit",	"DEIT", "deit",
						"ENDE", "deen",	"DEEN", "deen",
						"PLDE", "depl",	"DEPL", "depl",
						"ESDE", "dees",	"DEES", "dees"
					),
					"http://pons.eu/dict/search/results/?q={searchEncoded}&in=&l={urlLanguagePart}",
					"PonsTable.css" );


var dictWoxikon = new dictionary (
					"woxikon", 
					"www.woxikon.de",
					new Array (
						"ENDE", "deutsch-englisch",			"DEEN", "deutsch-englisch",
						"FRDE", "deutsch-franzoesisch",		"DEFR", "deutsch-franzoesisch", 
						"ITDE", "deutsch-italienisch",		"DEIT", "deutsch-italienisch",
						"ESDE", "deutsch-spanisch",			"DEES", "deutsch-spanisch",
						"NLDE", "deutsch-niederlaendisch",	"DENL", "deutsch-niederlaendisch",
						"SEDE", "deutsch-schwedisch",		"DESE", "deutsch-schwedisch",
						"PRDE", "deutsch-portugiesisch",	"DEPR", "deutsch-portugiesisch"
					),
					"http://www.woxikon.de/{urlLanguagePart}/{search}.php" );

var dictYahoo = new dictionary (
					"yahoo", 
					"babelfish.yahoo.com/",
					new Array (
						"ENDE", "en_de",	"DEEN", "de_en",
						"FRDE", "fr_de",	"DEFR", "de_fr", 
						"ENCN",	"en_zh", 	"CNEN", "zh_en",
						"ENNL",	"en_nl", 	"NLEN", "nl_en",
						"ENFR",	"en_fr", 	"FREN", "fr_en",
						"ENGR",	"en_el", 	"GREN", "el_en",
						"ENIT",	"en_it", 	"ITEN", "it_en",
						"ENJP",	"en_ja", 	"JPEN", "ja_en",
						"ENKR",	"en_ko", 	"KREN", "ko_en",
						"ENPR",	"en_pt", 	"PREN", "pt_en",
						"ENRU",	"en_ru", 	"RUEN", "ru_en",
						"ENES",	"en_es", 	"ESEN", "es_en",
						"ESFR",	"es_fr", 	"FRES", "fr_es",
						"NLFR",	"nl_fr", 	"FRNL", "fr_nl",
						"FRGR",	"fr_el", 	"GRFR", "el_fr",
						"FRIT",	"fr_it", 	"ITFR", "it_fr",
						"FRPR",	"fr_pt", 	"PRFR", "fr_pt"
					),
					"http://de.babelfish.yahoo.com/translate_txt?ei=UTF-8&doit=done&fr=bf-res&intl=1&tt=urltext&trtext={search}&lp={urlLanguagePart}&btnTrTxt=%C3%9Cbersetzen" );
				
// ListTypes				
const LT_SRC_LANGUAGES = 0;
const LT_TARGET_LANGUAGES = 1;
const LT_DICTIONARIES = 2;


function dictionaries ( strSrcLanguage, strTargetLanguage, strDictionary )
{
	this.m_srcLanguages = new Object;
	this.m_targetLanguages = new Object;
	this.m_dictionaries = new Object;
	this.m_currDictionary = null;
	
	this.m_strSrcLanguage = "";
	this.m_strTargetLanguage = "";
	this.m_strDictionary = "";
	
	this.addDictionary ( dictGoogle );
	this.addDictionary ( dictReverso );
	this.addDictionary ( dictPons );
	this.addDictionary ( dictLeo );
	this.addDictionary ( dictLangenscheidt );
	this.addDictionary ( dictWoxikon );
	this.addDictionary ( dictYahoo );

	this.setDictionaryValues ( strSrcLanguage, strTargetLanguage, strDictionary );
}


dictionaries.prototype.addDictionary = function ( dict )
{
	if ( this.m_dictionaries [ dict.m_strName ] )
		return; // already done

	this.m_dictionaries [ dict.m_strName ] = dict;
		
	for ( var i = 0; i < dict.m_strLanguages.length; i += 2 )
	{
		var currString = dict.m_strLanguages [ i ];
		var strSrcLanguage = currString.substr ( 0, 2 );
		var strTargetLanguage = currString.substr ( 2, 2 );

		if ( ! this.m_srcLanguages [ strSrcLanguage ] )
			this.m_srcLanguages [ strSrcLanguage ] = new Object;
		
		if ( ! this.m_targetLanguages [ strTargetLanguage ] )
			this.m_targetLanguages [ strTargetLanguage ] = new Object;
		
		if ( ! this.m_srcLanguages [ strSrcLanguage ] [ strTargetLanguage ] )
			this.m_srcLanguages 
					[ strSrcLanguage ] 
					[ strTargetLanguage ] = new Object;
		
		this.m_srcLanguages 
				[ strSrcLanguage ] 
				[ strTargetLanguage ]
				[ dict.m_strName ] = new Object;
				
		this.m_srcLanguages 
				[ strSrcLanguage ] 
				[ strTargetLanguage ] 
				[ dict.m_strName ]
				[ "urlLanguagePart" ] = dict.m_strLanguages [ i + 1 ];
	}
}

					
dictionaries.prototype.getList = function ( nListType, strSrcLanguage, strTargetLanguage )
{
	var outList = new Object;
			
	switch ( nListType )
	{
		case LT_SRC_LANGUAGES :
		{
			for ( prop in this.m_srcLanguages )
				outList [ prop ] = true;

			break;
		}
		
		case LT_TARGET_LANGUAGES :
		{
			if ( ! strSrcLanguage )
			{
				for ( prop in this.m_targetLanguages )
					outList [ prop ] = true;
			}
			else if ( this.m_srcLanguages [ strSrcLanguage ] )
			{
				for ( prop in this.m_srcLanguages [ strSrcLanguage ] )
					outList [ prop ] = true;
			}
			
			break;
		}

		case LT_DICTIONARIES :
		{
			if ( ! strSrcLanguage || ! strTargetLanguage )
			{
				for ( prop in this.m_dictionaries )
					outList [ prop ] = true;
			}
			
			else if ( this.m_srcLanguages [ strSrcLanguage ] [ strTargetLanguage ] )
			{
				for ( prop in this.m_srcLanguages 
									[ strSrcLanguage ] 
									[ strTargetLanguage ] )
					outList [ prop ] = true;
			}
			
			break;
		}
	}
	
	return outList;
}

					
dictionaries.prototype.getStyleSheet = function ()
{
	return this.m_currDictionary ? this.m_currDictionary.m_strName + ".xsl" : "";
}


dictionaries.prototype.getSrcLanguage = function ()
{
	return this.m_strSrcLanguage;
}


dictionaries.prototype.getTargetLanguage = function ()
{
	return this.m_strTargetLanguage;
}


dictionaries.prototype.getDictionary = function ()
{
	return this.m_strDictionary;
}


dictionaries.prototype.checkDictionaryValues = function ( strSrcLanguage, strTargetLanguage, strDictionary )
{
	var bResult = 
		this.m_srcLanguages != null && 
		this.m_srcLanguages [ strSrcLanguage ] != null &&
		this.m_srcLanguages [ strSrcLanguage ] [ strTargetLanguage ] != null && 
		this.m_srcLanguages [ strSrcLanguage ] [ strTargetLanguage ] [ strDictionary ] != null;
		
	dump ( "checkDictionaryValues==" + 
			String ( bResult ) + "{" + 
			strSrcLanguage + ":" + 
			strTargetLanguage + ":" + 
			strDictionary + "}\n" );
	
	return bResult;
}


dictionaries.prototype.setDictionaryValues = function ( strSrcLanguage, strTargetLanguage, strDictionary )
{
	if ( ! strSrcLanguage )
		strSrcLanguage = this.m_strSrcLanguage;
		
	if ( ! strTargetLanguage )
		strTargetLanguage = this.m_strTargetLanguage;
		
	if ( ! strDictionary )
		strDictionary = this.m_strDictionary;

	if ( this.checkDictionaryValues ( strSrcLanguage, strTargetLanguage, strDictionary ) )
	{
		this.m_strSrcLanguage = strSrcLanguage;
		this.m_strTargetLanguage = strTargetLanguage;
		this.m_strDictionary = strDictionary;
		this.m_currDictionary = this.m_dictionaries [ strDictionary ];
		
		dump ( "setDictionaryValues: " + 
				this.m_strSrcLanguage + ":" + 
				this.m_strTargetLanguage + ":" + 
				this.m_strDictionary + "\n" );

		return true;
	}

	return false;
}


dictionaries.prototype.getCssStyleUrls = function ()
{
	if ( this.m_currDictionary )
		return new Array ().concat ( this.m_currDictionary.m_cssStyleUrls ); // copy!

	return new Array;
}


dictionaries.prototype.getUrlBase = function ()
{
	return this.m_currDictionary ? this.m_currDictionary.m_strUrlBase : "";
}


dictionaries.prototype.getUrl = function ( strSearch )
{
	var strUrlSearch = "";
	
	if ( this.m_currDictionary )
	{
		var languagePair = 
				this.m_srcLanguages [ this.m_strSrcLanguage ] [ this.m_strTargetLanguage ];
		var strUrlLanguagePart = 
				this.m_srcLanguages 
					[ this.m_strSrcLanguage ] 
					[ this.m_strTargetLanguage ] 
					[ this.m_strDictionary ].urlLanguagePart;
		
		strUrlSearch = this.m_currDictionary.m_strUrlSearch;
		strUrlSearch = strUrlSearch.replace ( /{urlLanguagePart}/g, strUrlLanguagePart );
		strUrlSearch = strUrlSearch.replace ( /{search}/g, strSearch );
		strUrlSearch = strUrlSearch.replace ( /{searchEncoded}/g, encodeURIComponent ( strSearch ) );
	}

	return strUrlSearch;
}
